/*
 * MAX : devices.h.linuxlab, Sam Dez 29 20:14:41 CET 2001 -sg
 * 
 * This is the devices.h configured for linuxlab
 *
 * This file is part of Max data acquisition software
 * Copyright (C) 1998 Christian Rosen
 *
 * Max is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * Max is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file COPYING) in this directory; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DEVICES_H
#define DEVICES_H
#include "list.hh"
#include "sched.hh"

int adc_init   (List *, Scheduler *);
int adc        (List *, Scheduler *);
int adc_pre    (List *, Scheduler *);

io612_init (List *, Scheduler *);
io612_pre (List *, Scheduler *);
io612 (List *, Scheduler *);
io612_close (List *, Scheduler *);

hytec640_init (List *, Scheduler *);
hytec640_pre (List *, Scheduler *);
hytec640 (List *, Scheduler *);
hytec640_close (List *, Scheduler *);

ads1612_init (List *, Scheduler *);
ads1612_pre (List *, Scheduler *);
ads1612 (List *, Scheduler *);
ads1612_close (List *, Scheduler *);

adc520_init (List *, Scheduler *);
adc520_pre (List *, Scheduler *);
adc520 (List *, Scheduler *);
adc520_close (List *, Scheduler *);

dsp3016_init (List *, Scheduler *);
dsp3016_pre (List *, Scheduler *);
dsp3016 (List *, Scheduler *);
dsp3016_close (List *, Scheduler *);

adc2249_init (List *, Scheduler *);
adc2249_pre (List *, Scheduler *);
adc2249 (List *, Scheduler *);
adc2249_close (List *, Scheduler *);

bttv_init (List *, Scheduler *);
bttv_pre (List *, Scheduler *);
bttv (List *, Scheduler *);
bttv_close (List *, Scheduler *);

scanmate_init (List *, Scheduler *);
scanmate_pre (List *, Scheduler *);
scanmate (List *, Scheduler *);
scanmate_close (List *, Scheduler *);

le2323_init (List *, Scheduler *);
le2323_pre (List *, Scheduler *);
le2323 (List *, Scheduler *);
le2323_close (List *, Scheduler *);

tr8837_init (List *, Scheduler *);
tr8837_pre (List *, Scheduler *);
tr8837 (List *, Scheduler *);
tr8837_close (List *, Scheduler *);

sr400_init (List *, Scheduler *);
sr400_pre (List *, Scheduler *);
sr400 (List *, Scheduler *);
sr400_close (List *, Scheduler *);

/* number of devices without adc */
#define NUMBER_DEVICES 11

int (*Function_List      [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612,
hytec640,
ads1612,
adc520,
dsp3016,
adc2249,
bttv,
scanmate,
le2323,
tr8837,
sr400
};

int (*Pre_Function_List  [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_pre,
hytec640_pre,
ads1612_pre,
adc520_pre,
dsp3016_pre,
adc2249_pre,
bttv_pre,
scanmate_pre,
le2323_pre,
tr8837_pre,
sr400_pre
};

int (*Init_Function_List [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_init,
hytec640_init,
ads1612_init,
adc520_init,
dsp3016_init,
adc2249_init,
bttv_init,
scanmate_init,
le2323_init,
tr8837_init,
sr400_init
};

int (*Close_Function_List[NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_close,
hytec640_close,
ads1612_close,
adc520_close,
dsp3016_close,
adc2249_close,
bttv_close,
scanmate_close,
le2323_close,
tr8837_close,
sr400_close
};

#endif
